#dbus disabled until dbus-binding-tool is included in the devel-libs
%define build_dbus 0
%define build_perl 1
%define build_python 1
%define build_tcl 1
%define build_textfe 0
%define build_plf 1

%{?_with_plf: %{expand: %%global build_plf 1}}

%{?_without_dbus: %{expand: %%global build_dbus 0}}
%{?_with_dbus: %{expand: %%global build_dbus 1}}

%{?_without_perl: %{expand: %%global build_perl 0}}
%{?_with_perl: %{expand: %%global build_perl 1}}

%{?_without_python: %{expand: %%global build_python 0}}
%{?_with_python: %{expand: %%global build_python 1}}

%{?_without_tcl: %{expand: %%global build_tcl 0}}
%{?_with_tcl: %{expand: %%global build_tcl 1}}

Summary:		Graphical IRC (chat) client
Summary(fr):		Client IRC (chat) avec interface graphique
Summary(de):		IRC-Client (Chat) mit grafischer Oberfläche

%define name		xchat
%define version		2.6.1
%define release		1%{_my_ext}

Name:		%{name}
Version:	%{version}
Release:	%{release}
Group:		Networking/IRC
Vendor:		%{vendor}
Packager:	%{packager}
Distribution:	%{distribution}
License:	GPL
URL:		http://www.xchat.org
Source0:	%{name}-%{version}.tar.bz2
Source1:	xchatb_16.xpm.bz2
Source2:	xchatb_32.xpm.bz2
Source3:	xchatb_48.xpm.bz2
Source4:	mailcheck.so.bz2
Patch1:         xchat-2.4.1-firefox.patch.bz2
Patch2:         xchat-2.0.8-nicksuffix.patch.bz2
Patch3:         xchat-2.0.4-ctcp_version.patch.bz2
Patch4:         xchat-2.6.1-servlist.patch.bz2

%define perl_version	%(rpm -q --qf '%%{epoch}:%%{VERSION}' perl)
%define python_version	%(rpm -q --qf '%%{version}' python)
%define tcl_version	%(rpm -q --qf '%%{version}' tcl)

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

Requires:	gtk2
Requires:	openssl

BuildRequires:	bison
BuildRequires:	gtk+2-devel
BuildRequires:	openssl-devel
BuildRequires:	ImageMagick
BuildRequires:  GConf2
%if %build_perl
BuildRequires:  perl-devel
%endif
%if %build_python
BuildRequires:  python-devel
%endif
%if %build_tcl
BuildRequires:  tcl
%endif
%if %build_dbus
BuildRequires:  dbus-devel >= 0.50
BuildRequires:  libtool
%endif
%if %build_plf
BuildRequires:  socks5-devel >= 1.0r11
%endif

%description
A GUI IRC client with DCC file transfers, C plugin interface, Perl
and Python scripting capability, mIRC color, shaded transparency,
tabbed channels and more. It is pretty easy to use compared to the
other Gtk+ IRC clients and the interface is quite nicely designed.

This build includes the orginal mailcheck as a plugin.

Build Options:
--with dbus       Enable DBus plugin
--with textfe     Enable text frontend (console)
--without plf     Enable SOCKS5 support (need to download from PLF)
--without perl    Disable Perl plugin
--without python  Disable Python plugin
--without tcl     Disable TCL plugin

%package devel
Summary:	XChat header for plugin development
Group:		Networking/IRC

%description devel
This package contains xchat-plugin.h needed to build external plugins.

%if %build_perl
%package perl
Summary:	XChat Perl plugin
Group:		Networking/IRC
Requires:       %{name} = %{version}-%{release}
Requires:	perl-base = %perl_version

%description perl
Provides Perl scripting capability to XChat.
%endif

%if %build_python
%package python
Summary:	XChat Python plugin
Group:		Networking/IRC
Requires:	%{name} = %{version}-%{release}
Requires:	python = %python_version

%description python
Provides Python scripting capability to XChat.
%endif

%if %build_tcl
%package tcl
Summary:	XChat TCL plugin
Group:		Networking/IRC
Requires:       %{name} = %{version}-%{release}
Requires:	tcl = %tcl_version

%description tcl
Provides TCL scripting capability to XChat.
%endif

%if %build_dbus
%package dbus
Summary:        XChat DBUS plugin
Group:          Networking/IRC
Requires:       %{name} = %{version}

%description dbus
Provides DBUS managment capabilities to XChat.
%endif

%prep
%setup -q
%patch1 -p0 -b .firefox
%patch2 -p1
%patch3
%patch4 -p0 -b .default_server

%build

%if %{mdkversion} < 1010
%define __libtoolize /bin/true
%endif

%configure2_5x  --enable-openssl \
                --enable-ipv6 \
                --enable-hebrew \
                --enable-japanese-conv \
%if %build_perl
                --enable-perl \
%else
                --disable-perl \
%endif
%if %build_dbus
                --enable-dbus \
%else
                --disable-dbus \
%endif
%if %build_python
                --enable-python \
%else
                --disable-python \
%endif
%if %build_tcl
                --enable-tcl=%{_libdir} \
%else
                --disable-tcl
%endif
	        --enable-shm \
%if %build_textfe
	        --enable-textfe \
%endif
%if %build_plf
                --enable-socks
%endif

%make

%install

mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications $RPM_BUILD_ROOT%{_datadir}/pixmaps $RPM_BUILD_ROOT%{_libdir}/xchat/plugins

%makeinstall
strip -R .note -R .comment $RPM_BUILD_ROOT%{_libdir}/perl.so
strip -R .note -R .comment $RPM_BUILD_ROOT%{_libdir}/python.so
strip -R .note -R .comment $RPM_BUILD_ROOT%{_libdir}/tcl.so

mv $RPM_BUILD_ROOT%{_libdir}/perl.so $RPM_BUILD_ROOT%{_libdir}/xchat/plugins/perl.so
mv $RPM_BUILD_ROOT%{_libdir}/python.so $RPM_BUILD_ROOT%{_libdir}/xchat/plugins/python.so
mv $RPM_BUILD_ROOT%{_libdir}/tcl.so $RPM_BUILD_ROOT%{_libdir}/xchat/plugins/tcl.so

mv $RPM_BUILD_ROOT%{_libdir}/perl.la $RPM_BUILD_ROOT%{_libdir}/xchat/plugins/
mv $RPM_BUILD_ROOT%{_libdir}/python.la $RPM_BUILD_ROOT%{_libdir}/xchat/plugins/
mv $RPM_BUILD_ROOT%{_libdir}/tcl.la $RPM_BUILD_ROOT%{_libdir}/xchat/plugins/

mkdir -p $RPM_BUILD_ROOT/usr/share/icons
cp %_builddir/%{name}-%{version}/%{name}.xpm $RPM_BUILD_ROOT/usr/share/icons/%{name}.xpm

#install the orginal mailcheck for xchat
bzcat %{SOURCE4} > $RPM_BUILD_ROOT%{_libdir}/xchat/plugins/mailcheck.so

rm -f $RPM_BUILD_ROOT%{_libdir}/*.a

mkdir -p $RPM_BUILD_ROOT%{_iconsdir}/ $RPM_BUILD_ROOT%{_liconsdir}/ $RPM_BUILD_ROOT%{_miconsdir}/ $RPM_BUILD_ROOT%{_menudir}
bzcat %{SOURCE1} > $RPM_BUILD_ROOT%{_miconsdir}/xchat.xpm
bzcat %{SOURCE2} > $RPM_BUILD_ROOT%{_iconsdir}/xchat.xpm
bzcat %{SOURCE3} > $RPM_BUILD_ROOT%{_liconsdir}/xchat.xpm

cat > $RPM_BUILD_ROOT%{_menudir}/%{name} << EOF
?package(%name): needs="x11" \
	section="Networking/IRC" \
	title="Xchat" \
	longtitle="Graphical IRC (chat) client" \
	command="%{_bindir}/%{name}" \
	icon="/usr/share/icons/%{name}.xpm"
EOF

%find_lang %name

mkdir -p %{buildroot}%{_includedir}
cp plugins/xchat-plugin.h %{buildroot}%{_includedir}/

%post
%update_menus

%if %build_dbus
%post dbus
export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
gconftool-2 --makefile-install-rule %{_sysconfdir}/gconf/schemas/apps_xchat_url_handler.schemas > /dev/null

%preun dbus
export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
gconftool-2 --makefile-uninstall-rule %{_sysconfdir}/gconf/schemas/apps_xchat_url_handler.schemas > /dev/null
%endif

%postun
%clean_menus

%clean
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%files -f %{name}.lang
%defattr(-,root,root)
%doc AUTHORS README HACKING INSTALL ChangeLog faq.html COPYING plugins/plugin20.html plugins/perl/xchat2-perldocs.html plugins/perl/xchat2-perl.html

%{_bindir}/xchat
%if %build_textfe
%{_bindir}/xchat-text
%endif
%{_datadir}/applications/xchat.desktop
%{_datadir}/pixmaps/%{name}.png
%{_menudir}/*
%{_iconsdir}/%{name}.xpm
%{_liconsdir}/%{name}.xpm
%{_miconsdir}/%{name}.xpm
%{_libdir}/xchat/plugins/mailcheck.so

%if %build_perl
%files perl
%defattr(-,root,root)
%doc README
%{_libdir}/xchat/plugins/perl.so
%{_libdir}/xchat/plugins/perl.la
%endif

%if %build_python
%files python
%defattr(-,root,root)
%doc README
%{_libdir}/xchat/plugins/python.so
%{_libdir}/xchat/plugins/python.la
%endif

%if %build_tcl
%files tcl
%defattr(-,root,root)
%doc README
%{_libdir}/xchat/plugins/tcl.so
%{_libdir}/xchat/plugins/tcl.la
%endif

%files devel
%defattr(-,root,root)
%{_includedir}/xchat-plugin.h

%if %build_dbus
%files dbus
%defattr(-,root,root)
%doc README
%{_bindir}/xchat-remote
%{_libdir}/xchat/plugins/dbus.so
%{_libdir}/xchat/plugins/dbus.la
%{_sysconfdir}/gconf/schemas/apps_xchat_url_handler.schemas
%endif

%changelog

* Sun Jan 15 2006 Scott Grayban <sgrayban@borgnet.us> 2.6.1
 - New version
 - dbus support is not included in this build because its
   still in the cooker and not in any updates to support
   pkg-config and dbus-binding-tool.

* Mon Oct 10 2005 Scott Grayban <sgrayban@borgnet.us>
 - rebuild for 2006

* Tue Sep 13 2005 Scott Grayban <sgrayban@borgnet.us> 2.4.5-1bng
 - New version

* Fri Jul 25 2005 Scott Grayban <sgrayban@borgnet.us> 2.4.4-3bng
 - Recompiled for TCL 8.4.11

* Fri Jun 24 2005 Scott Grayban <sgrayban@borgnet.us> 2.4.4-1bng
 - New version
